﻿Public Class frmSTK

    Private Sub cmdCommand_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCommand.Click
        Me.Cursor = Cursors.WaitCursor
        Me.cmdCommand.Enabled = False

        Module1.InitModem()

        Me.Cursor = Cursors.Default
        Me.cmdCommand.Enabled = True

    End Sub


    Private Sub cmdActivate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdActivate.Click

        If STKAPI.ActivateSTK = True Then
            Me.txtText.Text = "STK is on!"
        Else
            Me.txtText.Text = "Unable to activate STK!"
        End If
    End Sub

    Private Sub cmdDeactivate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdDeactivate.Click



        If STKAPI.DeactivateSTK = True Then
            Me.txtText.Text = "STK is deactivated!"
        Else
            Me.txtText.Text = "STK is NOT deactivated!"
        End If

    End Sub

    Private Sub cmdDisplayMM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdDisplayMM.Click
        
        If STKAPI.MainMenuDisplay = True Then
            Me.txtText.Text = STKAPI.MainMenuName & vbCrLf & STKAPI.MainMenuList

        Else
            Me.txtText.Text = "STK is unable to display the main menu."
        End If
    End Sub

    Private Sub cmdSubmitMain_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSubmitMain.Click


        If STKAPI.MainMenuSelect(CInt(Me.txtInputMain.Text)) = True Then
            Me.txtText.Text = "STK has received a Main Menu selection from user."

        Else
            Me.txtText.Text = "STK has received a Main Menu selection but it is unable to process the selection."
        End If
    End Sub




    Private Sub cmdDisplaySM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdDisplaySM.Click

        If STKAPI.SubMenuDisplay = True Then
            Me.txtText.Text = STKAPI.SubMenuName & vbCrLf & STKAPI.SubMenuList

        Else
            Me.txtText.Text = "STK is unable to display the sub menu."
        End If
    End Sub

    Private Sub cmdSubmitSub_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSubmitSub.Click


        'Display sub-menu

        If STKAPI.SubMenuSelect(CInt(Me.txtInputSub.Text)) = True Then
            Me.txtText.Text = "STK has received a Sub Menu selection from user."

        Else
            Me.txtText.Text = "STK has received a Sub Menu selection but it is unable to process the selection."
        End If

    End Sub
    Private Sub cmdDisplayRequest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdDisplayRequest.Click

        Dim sDisplay As String

        sDisplay = STKAPI.InputRequestDisplay

        If sDisplay <> Nothing Then
            Me.txtText.Text = sDisplay
        Else
            Me.txtText.Text = "Unable to display request from STK."
        End If
    End Sub

    Private Sub cmdInput_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdInput.Click

        If STKAPI.InputSubmit(Me.textInput.Text) = True Then
            Me.txtText.Text = "User input is succesfully submitted to STK."
        Else
            Me.txtText.Text = "User input fails to submit to STK."
        End If
    End Sub
    Private Sub cmdSTKStatus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSTKStatus.Click
        'To get the status of STK.
        'Return values is an integer representing status. The description of each status is as per STKStatus describe below:
        '    STKMainMenu = 0 (STK has a main menu to show to user)
        '    STKResponse = 1 (STK has a response to user's input)
        '    STKInputRequest = 3 (STK has a request to user for input)
        '    STKSubMenu = 6 (STK has a sub menu to show to user)
        '    STKSMSSent = 9 (STK has sent out a SMS)
        '    STKTimeOut = 98 (STK time out)
        '    STKSessionEnd = 99 (STK session ends)
        '    STKUnknown = 100 (Unknwn status)

        Dim iSTKStatus As Integer

        iSTKStatus = STKAPI.STKStatusGet


        If iSTKStatus = 0 Then
            Me.txtText.Text = "STK is ready to display Main Menu."
        ElseIf iSTKStatus = 6 Then
            Me.txtText.Text = "STK is ready to display Sub Menu."
        ElseIf iSTKStatus = 3 Then
            Me.txtText.Text = "STK is requesting an input from user."
        ElseIf iSTKStatus = 1 Then
            Me.txtText.Text = "STK has a response for user input."
        ElseIf iSTKStatus = 9 Then
            Me.txtText.Text = "Allow STK to send out a SMS?"
        ElseIf iSTKStatus = 98 Then
            Me.txtText.Text = "STK Time Out"
        ElseIf iSTKStatus = 99 Then
            Me.txtText.Text = "STK session ends."
        ElseIf iSTKStatus = 100 Then
            Me.txtText.Text = "STK status is unknown."
        Else

        End If
    End Sub

    Private Sub cmdResponse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdResponse.Click
        Dim sDisplay As String

        sDisplay = STKAPI.ResponseDisplay '<---corrected

        If sDisplay <> Nothing Then
            Me.txtText.Text = sDisplay
        Else
            Me.txtText.Text = "Unable to display the response from STK."
        End If
    End Sub
    Private Sub cmdSMS_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSMS.Click
        Dim sDisplay As String

        sDisplay = STKAPI.SMSSentDisplay

        If sDisplay <> Nothing Then
            Me.txtText.Text = sDisplay
        Else
            Me.txtText.Text = "User has allowed STK to send out SMS."
        End If
    End Sub

    Private Sub cmdStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdStop.Click

        If STKAPI.CloseSTK = True Then
            Me.txtText.Text = "STK Session is stopped by user."
        Else
            Me.txtText.Text = "Unable to stop STK Session."
        End If
    End Sub

    Private Sub mnuCOMPort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuCOMPort.Click
        'To find which COM port is the modem connected to; start search from port 1 to port 3

        Dim iCOMPort As Integer
        Me.txtText.Text = "Searching for STK Modem ..."

        iCOMPort = Modem.FindCOMPort(1, 255)
        If iCOMPort = 0 Then
            Me.txtText.Text = "STK Modem not detected!"
            Exit Sub
        Else
            Me.txtText.Text = "STK Modem detected at COM port no." & iCOMPort & "."
            Me.txtPort.Text = CStr(iCOMPort)
        End If
    End Sub

    Private Sub mnuSS_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSS.Click
        Dim iSS As Integer

        Me.txtText.Text = "Checking signal stregth ..."

        iSS = Modem.SignalStrength

        If iSS = -1 Then
            Me.txtText.Text = "Unable to get signal stregth!"

        ElseIf iSS = 0 Then
            Me.txtText.Text = "NO signal stregth!"

        ElseIf iSS = 1 Then
            Me.txtText.Text = "WEAK signal stregth!"

        ElseIf iSS = 2 Then
            Me.txtText.Text = "NORMAL signal stregth!"

        ElseIf iSS = 3 Then
            Me.txtText.Text = "STRONG signal stregth!"

        End If
    End Sub

    Private Sub mnuReboot_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuReboot.Click
        Dim iTry As Integer

        Me.txtText.Text = "STK Modem is rebooting ..."

        If Modem.Reboot = True Then
            Me.txtText.Text = "STK Modem successfully rebooted! Begin initialisation ..."

            'pause for 3 seconds
            Sleep(3000)

            'try 3 times
            For iTry = 1 To 3
                If Modem.Init(Me.txtPort.Text) = True Then
                    Me.txtText.Text = "STK Modem successfully initialised!"
                    Exit For
                Else
                    If iTry = 3 Then Me.txtText.Text = "STK Modem fail to initialise!"
                End If
            Next

        Else
            Me.txtText.Text = "STK Modem fail to reboot!"
        End If
    End Sub

    Private Sub mnuOperator_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuOperator.Click
        Me.txtText.Text = "The GSM network operator is " & Modem.OperatorName & "."
    End Sub

    Private Sub mnuSMS_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSMS.Click

        If Modem.IsConnectToGSM = True Then
            frmSMS.ShowDialog()

        Else
            MsgBox("STK Modem is NOT connected with network!", vbCritical)
        End If

    End Sub


    Private Sub mnuUSSD_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuUSSD.Click
        If Modem.IsConnectToGSM = True Then
            frmUSSD.ShowDialog()

        Else
            MsgBox("STK Modem is NOT connected with network!", vbCritical)
        End If
    End Sub

End Class
